/// Sa se numere obiectele intr-o fotografie.
/// Fotografia e codificata cu o matrice de carcatere
/// # - punct al obiectului, _ fundal


#include <fstream>
#include <algorithm>

std::ifstream fin("foto.in");
std::ofstream fout("foto.out");


const int MaxN = 500;
char foto[MaxN][MaxN]; /// codifica fotografia
int a[MaxN][MaxN];     /// a[i][j] = k (daca celula (i, j)
int n, m;              /// face parte din obiectul k
int nr_obj;

void ReadPhoto();
void Fill(int i, int j);
void CountObjects();
bool Ok(int i, int j);
void WriteSol();

int main()
{
    ReadPhoto();
    CountObjects();
    WriteSol();

    fin.close();
    fout.close();
}

void Fill(int i, int j)
{
    if (!Ok(i, j)) return;
    a[i][j] = nr_obj;
    Fill(i - 1, j);
    Fill(i, j + 1);
    Fill(i + 1, j);
    Fill(i, j - 1);
}

bool Ok(int i, int j)
{
    if (i < 1 || i > n || j < 1 || j > m) /// in afara matricei
        return false;
    if (foto[i][j] == '_') /// fundalul fotografiei
        return false;
    if (a[i][j])           /// celula deja marcata
        return false;
    return true;
}

void CountObjects()
{
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j)
            if (foto[i][j] == '#' && a[i][j] == 0) /// daca e un punct nemarcat al unui obiect
    {
        nr_obj++;
        Fill(i, j);
    }
}

void ReadPhoto()
{
    fin >> n >> m;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j)
            fin >> foto[i][j];
}

void WriteSol()
{
    fout << nr_obj << '\n';

    for (int i = 1; i <= n; ++i, fout << '\n')
        for (int j = 1; j <= m; ++j)
            fout << a[i][j] << ' ';
}
