/// Sa se numere obiectele intr-o fotografie.
/// Sa se afiseze suprafata obiectelor
/// Fotografia e codificata cu o matrice de carcatere
/// # - punct al obiectului, _ fundal


#include <fstream>
#include <algorithm>

std::ifstream fin("foto.in");
std::ofstream fout("foto.out");


const int MaxN = 500;
char foto[MaxN][MaxN]; /// codifica fotografia
int a[MaxN][MaxN];     /// a[i][j] = k (daca celula (i, j)
int n, m;              /// face parte din obiectul k
int nr_obj;
int S[MaxN];           /// S[i] - suprafata obiectului i
int I, J;

void ReadPhoto();
void Fill();
void CountObjects();
bool Ok();
void WriteSol();

int main()
{
    ReadPhoto();
    CountObjects();
    WriteSol();

    fin.close();
    fout.close();
}

void Fill() /// O(n * m)
{
    if (!Ok()) return;
    a[I][J] = nr_obj;
    S[nr_obj]++;

    I--; Fill(); I++;
    J++; Fill(); J--;
    I++; Fill(); I--;
    J--; Fill(); J++;
}

bool Ok()
{
    if (I < 1 || I > n || J < 1 || J > m) /// in afara matricei
        return false;
    if (foto[I][J] == '_') /// fundalul fotografiei
        return false;
    if (a[I][J])           /// celula deja marcata
        return false;
    return true;
}

void CountObjects()
{
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j)
            if (foto[i][j] == '#' && a[i][j] == 0) /// daca e un punct nemarcat al unui obiect
    {
        nr_obj++;
        I = i; J = j;
        Fill();
    }
}

void ReadPhoto()
{
    fin >> n >> m;
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j)
            fin >> foto[i][j];
}

void WriteSol()
{
    fout << nr_obj << '\n';

    for (int i = 1; i <= n; ++i, fout << '\n')
        for (int j = 1; j <= m; ++j)
            fout << a[i][j] << ' ';
    fout << "\nSuprafetele obiectelor: \n";
    for (int i = 1; i <= nr_obj; ++i)
        fout << S[i] << ' ';
}
